# -*- encoding : utf-8 -*-
DEFAULT_RUBY_PROF_OPTIONS = {
  filename: 'callgraph.html',
  printer: RubyProf::GraphHtmlPrinter
}

KCACHEGRIND_RUBY_PROF_OPTIONS = {
  filename: 'callgrind.trace',
  printer: RubyProf::CallTreePrinter
}

def ruby_prof(options = DEFAULT_RUBY_PROF_OPTIONS)
  RubyProf.start
  options = DEFAULT_RUBY_PROF_OPTIONS.merge options
  yield
ensure
  callgraph = RubyProf.stop

  callgraph.eliminate_methods!([
    /IRB::Irb#signal_status/,
    /Fixnum#>/,
    /Arel::/,
    /Array#each/,
    /Array#map/,
    /Enumerable#reduce/,
    /Enumerable#map/,
    /Enumerable#collect/,
    /Array#collect/,
    /Array#select/
  ])

  printer  = options.fetch(:printer)
  filename = options.fetch(:filename)

  printer.new(callgraph).print(File.new(filename, 'w'))
end
